diff -uNr openmp-3.5.0.src/runtime/src/kmp_runtime.c openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c
--- openmp-3.5.0.src/runtime/src/kmp_runtime.c	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c	2014-10-24 19:58:41.000000000 -0400
@@ -2617,127 +1646,109 @@
                 //     because initial code in teams should have level=0
                 team->t.t_level--;
                 // AC: call special invoker for outer "parallel" of the teams construct
-                invoker(gtid);
+                {
+                    KMP_TIME_BLOCK(OMP_work);
+                    invoker(gtid);
+                }
             } else {
 #endif /* OMP_40_ENABLED */
                 argv = args;
                 for( i=argc-1; i >= 0; --i )
-                /* TODO: revert workaround for Intel(R) 64 tracker #96 */
-                #if (KMP_ARCH_X86_64 || KMP_ARCH_ARM) && KMP_OS_LINUX
+// TODO: revert workaround for Intel(R) 64 tracker #96
+#if (KMP_ARCH_X86_64 || KMP_ARCH_ARM) && KMP_OS_LINUX
                     *argv++ = va_arg( *ap, void * );
-                #else
+#else
                     *argv++ = va_arg( ap, void * );
-                #endif
+#endif
                 KMP_MB();
-                __kmp_invoke_microtask( microtask, gtid, 0, argc, args );
+                {
+                    KMP_TIME_BLOCK(OMP_work);
+                    __kmp_invoke_microtask( microtask, gtid, 0, argc, args );
+                }
 #if OMP_40_ENABLED
             }
 #endif /* OMP_40_ENABLED */
         }
+        else if ( call_context == fork_context_gnu ) {
+            // we were called from GNU native code
+            KA_TRACE( 20, ("__kmp_fork_call: T#%d serial exit\n", gtid ));
+            return FALSE;
+        }
         else {
-            KMP_ASSERT2( exec_master <= 1, "__kmp_fork_call: unknown parameter exec_master" );
+            KMP_ASSERT2( call_context < fork_context_last, "__kmp_fork_call: unknown fork_context parameter" );
         }
 
-        KA_TRACE( 20, ("__kmp_fork_call: T#%d serial exit\n", gtid ));
 
+        KA_TRACE( 20, ("__kmp_fork_call: T#%d serial exit\n", gtid ));
         KMP_MB();
         return FALSE;
     }
 
-#if OMP_30_ENABLED
     // GEH: only modify the executing flag in the case when not serialized
     //      serialized case is handled in kmpc_serialized_parallel
     KF_TRACE( 10, ( "__kmp_fork_call: parent_team_aclevel=%d, master_th=%p, curtask=%p, curtask_max_aclevel=%d\n",
-                    parent_team->t.t_active_level, master_th, master_th->th.th_current_task,
-                    master_th->th.th_current_task->td_icvs.max_active_levels ) );
+                  parent_team->t.t_active_level, master_th, master_th->th.th_current_task,
+                  master_th->th.th_current_task->td_icvs.max_active_levels ) );
     // TODO: GEH - cannot do this assertion because root thread not set up as executing
     // KMP_ASSERT( master_th->th.th_current_task->td_flags.executing == 1 );
     master_th->th.th_current_task->td_flags.executing = 0;
-#endif
 
 #if OMP_40_ENABLED
-    if ( !master_th->th.th_team_microtask || level > teams_level )
+    if ( !master_th->th.th_teams_microtask || level > teams_level )
 #endif /* OMP_40_ENABLED */
     {
         /* Increment our nested depth level */
         KMP_TEST_THEN_INC32( (kmp_int32*) &root->r.r_in_parallel );
     }
 
-#if OMP_30_ENABLED
-    //
     // See if we need to make a copy of the ICVs.
-    //
     int nthreads_icv = master_th->th.th_current_task->td_icvs.nproc;
-    if ( ( level + 1 < __kmp_nested_nth.used ) &&
-      ( __kmp_nested_nth.nth[level + 1] != nthreads_icv ) ) {
-        nthreads_icv = __kmp_nested_nth.nth[level + 1];
+    if ((level+1 < __kmp_nested_nth.used) && (__kmp_nested_nth.nth[level+1] != nthreads_icv)) {
+        nthreads_icv = __kmp_nested_nth.nth[level+1];
     }
     else {
         nthreads_icv = 0;  // don't update
     }
 
 #if OMP_40_ENABLED
-    //
     // Figure out the proc_bind_policy for the new team.
-    //
     kmp_proc_bind_t proc_bind = master_th->th.th_set_proc_bind;
-    kmp_proc_bind_t proc_bind_icv; // proc_bind_default means don't update
-
+    kmp_proc_bind_t proc_bind_icv = proc_bind_default; // proc_bind_default means don't update
     if ( master_th->th.th_current_task->td_icvs.proc_bind == proc_bind_false ) {
         proc_bind = proc_bind_false;
-        proc_bind_icv = proc_bind_default;
     }
     else {
-        proc_bind_icv = master_th->th.th_current_task->td_icvs.proc_bind;
-        if ( proc_bind == proc_bind_default ) {
-            //
-            // No proc_bind clause was specified, so use the current value
-            // of proc-bind-var for this parallel region.
-            //
-            proc_bind = proc_bind_icv;
-        }
-        else {
-            //
-            // The proc_bind policy was specified explicitly on the parallel
-            // clause.  This overrides the proc-bind-var for this parallel
-            // region, but does not change proc-bind-var.
-            //
+        if (proc_bind == proc_bind_default) {
+            // No proc_bind clause specified; use current proc-bind-var for this parallel region
+            proc_bind = master_th->th.th_current_task->td_icvs.proc_bind;
         }
-
-        //
+        /* else: The proc_bind policy was specified explicitly on parallel clause. This
+           overrides proc-bind-var for this parallel region, but does not change proc-bind-var. */
         // Figure the value of proc-bind-var for the child threads.
-        //
-        if ( ( level + 1 < __kmp_nested_proc_bind.used )
-          && ( __kmp_nested_proc_bind.bind_types[level + 1] != proc_bind_icv ) ) {
-            proc_bind_icv = __kmp_nested_proc_bind.bind_types[level + 1];
-        }
-        else {
-            proc_bind_icv = proc_bind_default;
+        if ((level+1 < __kmp_nested_proc_bind.used)
+            && (__kmp_nested_proc_bind.bind_types[level+1] != master_th->th.th_current_task->td_icvs.proc_bind)) {
+            proc_bind_icv = __kmp_nested_proc_bind.bind_types[level+1];
         }
     }
 
-    //
     // Reset for next parallel region
-    //
     master_th->th.th_set_proc_bind = proc_bind_default;
 #endif /* OMP_40_ENABLED */
 
-    if ( ( nthreads_icv > 0 )
+    if ((nthreads_icv > 0)
 #if OMP_40_ENABLED
-      || ( proc_bind_icv != proc_bind_default )
+        || (proc_bind_icv != proc_bind_default)
 #endif /* OMP_40_ENABLED */
-      )
-    {
+        ) {
         kmp_internal_control_t new_icvs;
-        copy_icvs( & new_icvs, & master_th->th.th_current_task->td_icvs );
+        copy_icvs(&new_icvs, &master_th->th.th_current_task->td_icvs);
         new_icvs.next = NULL;
-
-        if ( nthreads_icv > 0 ) {
+        if (nthreads_icv > 0) {
             new_icvs.nproc = nthreads_icv;
         }
 
 #if OMP_40_ENABLED
-        if ( proc_bind_icv != proc_bind_default ) {
+        if (proc_bind_icv != proc_bind_default) {
             new_icvs.proc_bind = proc_bind_icv;
         }
 #endif /* OMP_40_ENABLED */
@@ -2746,47 +1757,31 @@
         KF_TRACE( 10, ( "__kmp_fork_call: before __kmp_allocate_team\n" ) );
         team = __kmp_allocate_team(root, nthreads, nthreads,
 #if OMP_40_ENABLED
-          proc_bind,
+                                   proc_bind,
 #endif
-          &new_icvs, argc );
-    } else
-#endif /* OMP_30_ENABLED */
-    {
+                                   &new_icvs, argc USE_NESTED_HOT_ARG(master_th) );
+    } else {
         /* allocate a new parallel team */
         KF_TRACE( 10, ( "__kmp_fork_call: before __kmp_allocate_team\n" ) );
         team = __kmp_allocate_team(root, nthreads, nthreads,
 #if OMP_40_ENABLED
-                proc_bind,
+                                   proc_bind,
 #endif
-#if OMP_30_ENABLED
-                &master_th->th.th_current_task->td_icvs,
-#else
-                parent_team->t.t_set_nproc[master_tid],
-                parent_team->t.t_set_dynamic[master_tid],
-                parent_team->t.t_set_nested[master_tid],
-                parent_team->t.t_set_blocktime[master_tid],
-                parent_team->t.t_set_bt_intervals[master_tid],
-                parent_team->t.t_set_bt_set[master_tid],
-#endif // OMP_30_ENABLED
-                argc );
+                                   &master_th->th.th_current_task->td_icvs, argc
+                                   USE_NESTED_HOT_ARG(master_th) );
     }
-
-    KF_TRACE( 10, ( "__kmp_fork_call: after __kmp_allocate_team - team = %p\n",
-            team ) );
+    KF_TRACE( 10, ( "__kmp_fork_call: after __kmp_allocate_team - team = %p\n", team ) );
 
     /* setup the new team */
     team->t.t_master_tid = master_tid;
     team->t.t_master_this_cons = master_this_cons;
-    team->t.t_master_last_cons = master_last_cons;
-
+    team->t.t_ident      = loc;
     team->t.t_parent     = parent_team;
     TCW_SYNC_PTR(team->t.t_pkfn, microtask);
     team->t.t_invoke     = invoker;  /* TODO move this to root, maybe */
-    team->t.t_ident      = loc;
-#if OMP_30_ENABLED
     // TODO: parent_team->t.t_level == INT_MAX ???
 #if OMP_40_ENABLED
-    if ( !master_th->th.th_team_microtask || level > teams_level ) {
+    if ( !master_th->th.th_teams_microtask || level > teams_level ) {
 #endif /* OMP_40_ENABLED */
         team->t.t_level        = parent_team->t.t_level + 1;
         team->t.t_active_level = parent_team->t.t_active_level + 1;
@@ -2797,33 +1792,22 @@
         team->t.t_active_level = parent_team->t.t_active_level;
     }
 #endif /* OMP_40_ENABLED */
-    team->t.t_sched      = get__sched_2( parent_team, master_tid ); // set master's schedule as new run-time schedule
+    team->t.t_sched      = get__sched_2(parent_team, master_tid); // set master's schedule as new run-time schedule
 
-#if KMP_ARCH_X86 || KMP_ARCH_X86_64
-    if ( __kmp_inherit_fp_control ) {
-        __kmp_store_x87_fpu_control_word( &team->t.t_x87_fpu_control_word );
-        __kmp_store_mxcsr( &team->t.t_mxcsr );
-        team->t.t_mxcsr &= KMP_X86_MXCSR_MASK;
-        team->t.t_fp_control_saved = TRUE;
-    }
-    else {
-        team->t.t_fp_control_saved = FALSE;
-    }
-#endif /* KMP_ARCH_X86 || KMP_ARCH_X86_64 */
+    // Update the floating point rounding in the team if required.
+    propagateFPControl(team);
 
     if ( __kmp_tasking_mode != tskm_immediate_exec ) {
-        //
-        // Set the master thread's task team to the team's task team.
-        // Unless this is the hot team, it should be NULL.
-        //
+        // Set master's task team to team's task team. Unless this is hot team, it should be NULL.
         KMP_DEBUG_ASSERT( master_th->th.th_task_team == parent_team->t.t_task_team );
         KA_TRACE( 20, ( "__kmp_fork_call: Master T#%d pushing task_team %p / team %p, new task_team %p / team %p\n",
-                        __kmp_gtid_from_thread( master_th ), master_th->th.th_task_team,
-                        parent_team, team->t.t_task_team, team ) );
+                      __kmp_gtid_from_thread( master_th ), master_th->th.th_task_team,
+                      parent_team, team->t.t_task_team, team ) );
         master_th->th.th_task_team = team->t.t_task_team;
-        KMP_DEBUG_ASSERT( ( master_th->th.th_task_team == NULL ) || ( team == root->r.r_hot_team ) ) ;
+#if !KMP_NESTED_HOT_TEAMS
+        KMP_DEBUG_ASSERT((master_th->th.th_task_team == NULL) || (team == root->r.r_hot_team));
+#endif
     }
-#endif // OMP_30_ENABLED
 
     KA_TRACE( 20, ("__kmp_fork_call: T#%d(%d:%d)->(%d:0) created a team of %d threads\n",
                 gtid, parent_team->t.t_id, team->t.t_master_tid, team->t.t_id, team->t.t_nproc ));
@@ -2833,12 +1817,12 @@
     KMP_MB();
 
     /* now, setup the arguments */
-    argv = (void**) team -> t.t_argv;
+    argv = (void**)team->t.t_argv;
 #if OMP_40_ENABLED
     if ( ap ) {
 #endif /* OMP_40_ENABLED */
-        for( i=argc-1; i >= 0; --i )
-/* TODO: revert workaround for Intel(R) 64 tracker #96 */
+        for ( i=argc-1; i >= 0; --i )
+// TODO: revert workaround for Intel(R) 64 tracker #96
 #if (KMP_ARCH_X86_64 || KMP_ARCH_ARM) && KMP_OS_LINUX
             *argv++ = va_arg( *ap, void * );
 #else
@@ -2846,31 +1830,19 @@
 #endif
 #if OMP_40_ENABLED
     } else {
-        for( i=0; i < argc; ++i )
+        for ( i=0; i < argc; ++i )
             // Get args from parent team for teams construct
             argv[i] = team->t.t_parent->t.t_argv[i];
     }
 #endif /* OMP_40_ENABLED */
 
     /* now actually fork the threads */
-
     team->t.t_master_active = master_active;
-    if (!root -> r.r_active)  /* Only do the assignment if it makes a difference to prevent cache ping-pong */
-        root -> r.r_active = TRUE;
+    if (!root->r.r_active) // Only do assignment if it prevents cache ping-pong
+        root->r.r_active = TRUE;
 
     __kmp_fork_team_threads( root, team, master_th, gtid );
-    __kmp_setup_icv_copy(team, nthreads
-#if OMP_30_ENABLED
-			 , &master_th->th.th_current_task->td_icvs, loc
-#else
-			 , parent_team->t.t_set_nproc[master_tid],
-			 parent_team->t.t_set_dynamic[master_tid],
-			 parent_team->t.t_set_nested[master_tid],
-			 parent_team->t.t_set_blocktime[master_tid],
-			 parent_team->t.t_set_bt_intervals[master_tid],
-			 parent_team->t.t_set_bt_set[master_tid]
-#endif /* OMP_30_ENABLED */
-			 );
+    __kmp_setup_icv_copy( team, nthreads, &master_th->th.th_current_task->td_icvs, loc );
 
 
     __kmp_release_bootstrap_lock( &__kmp_forkjoin_lock );
@@ -2878,20 +1850,30 @@
 
 #if USE_ITT_BUILD
     // Mark start of "parallel" region for VTune. Only use one of frame notification scheme at the moment.
-    if ( ( __itt_frame_begin_v3_ptr && __kmp_forkjoin_frames && ! __kmp_forkjoin_frames_mode ) || KMP_ITT_DEBUG )
+    if ((__itt_frame_begin_v3_ptr && __kmp_forkjoin_frames && !__kmp_forkjoin_frames_mode) || KMP_ITT_DEBUG)
 # if OMP_40_ENABLED
-    if ( !master_th->th.th_team_microtask || microtask == (microtask_t)__kmp_teams_master )
-        // Either not in teams or the outer fork of the teams construct
+        if (!master_th->th.th_teams_microtask || microtask == (microtask_t)__kmp_teams_master)
+            // Either not in teams or the outer fork of the teams construct
 # endif /* OMP_40_ENABLED */
-        __kmp_itt_region_forking( gtid );
-#endif /* USE_ITT_BUILD */
+        {
+            __kmp_itt_region_forking(gtid, team->t.t_nproc, 0);
+        }
+    kmp_uint64 tmp_time = 0;
+#if USE_ITT_NOTIFY
+    if ( __itt_get_timestamp_ptr )
+        tmp_time = __itt_get_timestamp();
+#endif
+    if ((__itt_frame_submit_v3_ptr && __kmp_forkjoin_frames_mode==3)|| KMP_ITT_DEBUG)
+# if OMP_40_ENABLED
+        if (!master_th->th.th_teams_microtask || microtask == (microtask_t)__kmp_teams_master)
+            // Either not in teams or the outer fork of the teams construct
+# endif /* OMP_40_ENABLED */
+            team->t.t_region_time = tmp_time;
 
-#if USE_ITT_BUILD && USE_ITT_NOTIFY && OMP_30_ENABLED
     // Internal fork - report frame begin
-    if( ( __kmp_forkjoin_frames_mode == 1 || __kmp_forkjoin_frames_mode == 3 ) && __itt_frame_submit_v3_ptr && __itt_get_timestamp_ptr )
-    {
-        if( ! ( team->t.t_active_level > 1 ) ) {
-            master_th->th.th_frame_time   = __itt_get_timestamp();
+    if ((__kmp_forkjoin_frames_mode == 1 || __kmp_forkjoin_frames_mode == 3) && __itt_frame_submit_v3_ptr ) {
+        if (!(team->t.t_active_level > 1)) {
+            master_th->th.th_frame_time  = tmp_time;
         }
     }
 #endif /* USE_ITT_BUILD */
@@ -2899,8 +1881,8 @@
     /* now go on and do the work */
     KMP_DEBUG_ASSERT( team == __kmp_threads[gtid]->th.th_team );
     KMP_MB();
-
-    KF_TRACE( 10, ( "__kmp_internal_fork : root=%p, team=%p, master_th=%p, gtid=%d\n", root, team, master_th, gtid ) );
+    KF_TRACE(10, ("__kmp_internal_fork : root=%p, team=%p, master_th=%p, gtid=%d\n",
+                  root, team, master_th, gtid));
 
 #if USE_ITT_BUILD
     if ( __itt_stack_caller_create_ptr ) {
@@ -2913,10 +1895,11 @@
 #endif /* OMP_40_ENABLED */
     {
         __kmp_internal_fork( loc, gtid, team );
-        KF_TRACE( 10, ( "__kmp_internal_fork : after : root=%p, team=%p, master_th=%p, gtid=%d\n", root, team, master_th, gtid ) );
+        KF_TRACE(10, ("__kmp_internal_fork : after : root=%p, team=%p, master_th=%p, gtid=%d\n",
+                      root, team, master_th, gtid));
     }
 
-    if (! exec_master) {
+    if (call_context == fork_context_gnu) {
         KA_TRACE( 20, ("__kmp_fork_call: parallel exit T#%d\n", gtid ));
         return TRUE;
     }
@@ -2924,9 +1907,14 @@
     /* Invoke microtask for MASTER thread */
     KA_TRACE( 20, ("__kmp_fork_call: T#%d(%d:0) invoke microtask = %p\n",
                 gtid, team->t.t_id, team->t.t_pkfn ) );
+    }  // END of timer KMP_fork_call block
 
-    if (! team->t.t_invoke( gtid )) {
-        KMP_ASSERT2( 0, "cannot invoke microtask for MASTER thread" );
+    {
+        //KMP_TIME_BLOCK(OMP_work);
+        KMP_TIME_BLOCK(USER_master_invoke);
+        if (! team->t.t_invoke( gtid )) {
+            KMP_ASSERT2( 0, "cannot invoke microtask for MASTER thread" );
+        }
     }
     KA_TRACE( 20, ("__kmp_fork_call: T#%d(%d:0) done microtask = %p\n",
         gtid, team->t.t_id, team->t.t_pkfn ) );
@@ -2937,7 +1925,6 @@
     return TRUE;
 }
 
-
 void
 __kmp_join_call(ident_t *loc, int gtid
 #if OMP_40_ENABLED
@@ -2945,6 +1932,7 @@
 #endif /* OMP_40_ENABLED */
 )
 {
+    KMP_TIME_BLOCK(KMP_join_call);
     kmp_team_t     *team;
     kmp_team_t     *parent_team;
     kmp_info_t     *master_th;
@@ -2956,24 +1944,24 @@
 
     /* setup current data */
     master_th     = __kmp_threads[ gtid ];
-    root          = master_th -> th.th_root;
-    team          = master_th -> th.th_team;
+    root          = master_th->th.th_root;
+    team          = master_th->th.th_team;
     parent_team   = team->t.t_parent;
 
     master_th->th.th_ident = loc;
 
-#if OMP_30_ENABLED && KMP_DEBUG
+#if KMP_DEBUG
     if ( __kmp_tasking_mode != tskm_immediate_exec ) {
         KA_TRACE( 20, ( "__kmp_join_call: T#%d, old team = %p old task_team = %p, th_task_team = %p\n",
                          __kmp_gtid_from_thread( master_th ), team,
-                         team -> t.t_task_team, master_th->th.th_task_team) );
+                         team->t.t_task_team, master_th->th.th_task_team) );
         KMP_DEBUG_ASSERT( master_th->th.th_task_team == team->t.t_task_team );
     }
-#endif // OMP_30_ENABLED
+#endif
 
     if( team->t.t_serialized ) {
 #if OMP_40_ENABLED
-        if ( master_th->th.th_team_microtask ) {
+        if ( master_th->th.th_teams_microtask ) {
             // We are in teams construct
             int level = team->t.t_level;
             int tlevel = master_th->th.th_teams_level;
@@ -3012,7 +2000,7 @@
     // Mark end of "parallel" region for VTune. Only use one of frame notification scheme at the moment.
     if ( ( __itt_frame_end_v3_ptr && __kmp_forkjoin_frames && ! __kmp_forkjoin_frames_mode ) || KMP_ITT_DEBUG )
 # if OMP_40_ENABLED
-    if ( !master_th->th.th_team_microtask /* not in teams */ ||
+    if ( !master_th->th.th_teams_microtask /* not in teams */ ||
          ( !exit_teams && team->t.t_level == master_th->th.th_teams_level ) )
         // Either not in teams or exiting teams region
         // (teams is a frame and no other frames inside the teams)
@@ -3021,10 +2009,21 @@
         master_th->th.th_ident = loc;
         __kmp_itt_region_joined( gtid );
     }
+    if ( ( __itt_frame_submit_v3_ptr && __kmp_forkjoin_frames_mode == 3 ) || KMP_ITT_DEBUG )
+# if OMP_40_ENABLED
+    if ( !master_th->th.th_teams_microtask /* not in teams */ ||
+         ( !exit_teams && team->t.t_level == master_th->th.th_teams_level ) )
+        // Either not in teams or exiting teams region
+        // (teams is a frame and no other frames inside the teams)
+# endif /* OMP_40_ENABLED */
+    {
+        master_th->th.th_ident = loc;
+        __kmp_itt_frame_submit( gtid, team->t.t_region_time, master_th->th.th_frame_time, 0, loc, master_th->th.th_team_nproc, 1 );
+    }
 #endif /* USE_ITT_BUILD */
 
 #if OMP_40_ENABLED
-    if ( master_th->th.th_team_microtask &&
+    if ( master_th->th.th_teams_microtask &&
          !exit_teams &&
          team->t.t_pkfn != (microtask_t)__kmp_teams_master &&
          team->t.t_level == master_th->th.th_teams_level + 1 ) {
@@ -3038,9 +2037,9 @@
         KMP_TEST_THEN_DEC32( (kmp_int32*) &root->r.r_in_parallel );
 
         /* Restore number of threads in the team if needed */
-        if ( master_th->th.th_team_nproc < master_th->th.th_set_nth_teams ) {
+        if ( master_th->th.th_team_nproc < master_th->th.th_teams_size.nth ) {
             int old_num = master_th->th.th_team_nproc;
-            int new_num = master_th->th.th_set_nth_teams;
+            int new_num = master_th->th.th_teams_size.nth;
             kmp_info_t **other_threads = team->t.t_threads;
             team->t.t_nproc = new_num;
             for ( i = 0; i < old_num; ++i ) {
@@ -3051,8 +2050,9 @@
                 // Re-initialize thread's barrier data.
                 int b;
                 kmp_balign_t * balign = other_threads[i]->th.th_bar;
-                for ( b = 0; b < bp_last_bar; ++ b ) {
+                for ( b = 0; b < bs_last_barrier; ++ b ) {
                     balign[ b ].bb.b_arrived        = team->t.t_bar[ b ].b_arrived;
+                    KMP_DEBUG_ASSERT(balign[ b ].bb.wait_flag != KMP_BARRIER_PARENT_FLAG);
                 }
                 // Synchronize thread's task state
                 other_threads[i]->th.th_task_state = master_th->th.th_task_state;
@@ -3061,13 +2061,13 @@
         return;
     }
 #endif /* OMP_40_ENABLED */
+
     /* do cleanup and restore the parent team */
-    master_th -> th.th_info .ds.ds_tid = team -> t.t_master_tid;
-    master_th -> th.th_local.this_construct = team -> t.t_master_this_cons;
-    master_th -> th.th_local.last_construct = team -> t.t_master_last_cons;
+    master_th->th.th_info .ds.ds_tid = team->t.t_master_tid;
+    master_th->th.th_local.this_construct = team->t.t_master_this_cons;
 
-    master_th -> th.th_dispatch =
-                & parent_team -> t.t_dispatch[ team -> t.t_master_tid ];
+    master_th->th.th_dispatch =
+                & parent_team->t.t_dispatch[ team->t.t_master_tid ];
 
     /* jc: The following lock has instructions with REL and ACQ semantics,
        separating the parallel user code called in this parallel region
@@ -3076,7 +2076,7 @@
     __kmp_acquire_bootstrap_lock( &__kmp_forkjoin_lock );
 
 #if OMP_40_ENABLED
-    if ( !master_th->th.th_team_microtask || team->t.t_level > master_th->th.th_teams_level )
+    if ( !master_th->th.th_teams_microtask || team->t.t_level > master_th->th.th_teams_level )
 #endif /* OMP_40_ENABLED */
     {
         /* Decrement our nested depth level */
@@ -3084,32 +2084,24 @@
     }
     KMP_DEBUG_ASSERT( root->r.r_in_parallel >= 0 );
 
-    #if OMP_30_ENABLED
     KF_TRACE( 10, ("__kmp_join_call1: T#%d, this_thread=%p team=%p\n",
                    0, master_th, team ) );
     __kmp_pop_current_task_from_thread( master_th );
-    #endif // OMP_30_ENABLED
 
 #if OMP_40_ENABLED && KMP_AFFINITY_SUPPORTED
     //
     // Restore master thread's partition.
     //
-    master_th -> th.th_first_place = team -> t.t_first_place;
-    master_th -> th.th_last_place = team -> t.t_last_place;
+    master_th->th.th_first_place = team->t.t_first_place;
+    master_th->th.th_last_place = team->t.t_last_place;
 #endif /* OMP_40_ENABLED */
 
-#if KMP_ARCH_X86 || KMP_ARCH_X86_64
-    if ( __kmp_inherit_fp_control && team->t.t_fp_control_saved ) {
-        __kmp_clear_x87_fpu_status_word();
-        __kmp_load_x87_fpu_control_word( &team->t.t_x87_fpu_control_word );
-        __kmp_load_mxcsr( &team->t.t_mxcsr );
-    }
-#endif /* KMP_ARCH_X86 || KMP_ARCH_X86_64 */
+    updateHWFPControl (team);
 
-    if ( root -> r.r_active != master_active )
-        root -> r.r_active = master_active;
+    if ( root->r.r_active != master_active )
+        root->r.r_active = master_active;
 
-    __kmp_free_team( root, team ); /* this will free worker threads */
+    __kmp_free_team( root, team USE_NESTED_HOT_ARG(master_th) ); // this will free worker threads
 
     /* this race was fun to find.  make sure the following is in the critical
      * region otherwise assertions may fail occasiounally since the old team
@@ -3117,39 +2109,35 @@
      * actually safe to run and won't cause any bugs, but will cause thoose
      * assertion failures.  it's only one deref&assign so might as well put this
      * in the critical region */
-    master_th -> th.th_team        =   parent_team;
-    master_th -> th.th_team_nproc  =   parent_team -> t.t_nproc;
-    master_th -> th.th_team_master =   parent_team -> t.t_threads[0];
-    master_th -> th.th_team_serialized = parent_team -> t.t_serialized;
+    master_th->th.th_team        =   parent_team;
+    master_th->th.th_team_nproc  =   parent_team->t.t_nproc;
+    master_th->th.th_team_master =   parent_team->t.t_threads[0];
+    master_th->th.th_team_serialized = parent_team->t.t_serialized;
 
     /* restore serialized team, if need be */
-    if( parent_team -> t.t_serialized &&
+    if( parent_team->t.t_serialized &&
         parent_team != master_th->th.th_serial_team &&
         parent_team != root->r.r_root_team ) {
-            __kmp_free_team( root, master_th -> th.th_serial_team );
-            master_th -> th.th_serial_team = parent_team;
+            __kmp_free_team( root, master_th->th.th_serial_team USE_NESTED_HOT_ARG(NULL) );
+            master_th->th.th_serial_team = parent_team;
     }
 
-#if OMP_30_ENABLED
     if ( __kmp_tasking_mode != tskm_immediate_exec ) {
         //
         // Copy the task team from the new child / old parent team
         // to the thread.  If non-NULL, copy the state flag also.
         //
-        if ( ( master_th -> th.th_task_team = parent_team -> t.t_task_team ) != NULL ) {
-            master_th -> th.th_task_state = master_th -> th.th_task_team -> tt.tt_state;
+        if ( ( master_th->th.th_task_team = parent_team->t.t_task_team ) != NULL ) {
+            master_th->th.th_task_state = master_th->th.th_task_team->tt.tt_state;
         }
         KA_TRACE( 20, ( "__kmp_join_call: Master T#%d restoring task_team %p / team %p\n",
                         __kmp_gtid_from_thread( master_th ), master_th->th.th_task_team,
                         parent_team ) );
     }
-#endif /* OMP_30_ENABLED */
 
-    #if OMP_30_ENABLED
-         // TODO: GEH - cannot do this assertion because root thread not set up as executing
-         // KMP_ASSERT( master_th->th.th_current_task->td_flags.executing == 0 );
-         master_th->th.th_current_task->td_flags.executing = 1;
-    #endif // OMP_30_ENABLED
+     // TODO: GEH - cannot do this assertion because root thread not set up as executing
+     // KMP_ASSERT( master_th->th.th_current_task->td_flags.executing == 0 );
+     master_th->th.th_current_task->td_flags.executing = 1;
 
     __kmp_release_bootstrap_lock( &__kmp_forkjoin_lock );
 
@@ -3166,38 +2154,29 @@
 __kmp_save_internal_controls ( kmp_info_t * thread )
 {
 
-    if ( thread -> th.th_team != thread -> th.th_serial_team ) {
+    if ( thread->th.th_team != thread->th.th_serial_team ) {
         return;
     }
-    if (thread -> th.th_team -> t.t_serialized > 1) {
+    if (thread->th.th_team->t.t_serialized > 1) {
         int push = 0;
 
-        if (thread -> th.th_team -> t.t_control_stack_top == NULL) {
+        if (thread->th.th_team->t.t_control_stack_top == NULL) {
             push = 1;
         } else {
-            if ( thread -> th.th_team -> t.t_control_stack_top -> serial_nesting_level !=
-                 thread -> th.th_team -> t.t_serialized ) {
+            if ( thread->th.th_team->t.t_control_stack_top->serial_nesting_level !=
+                 thread->th.th_team->t.t_serialized ) {
                 push = 1;
             }
         }
         if (push) {  /* push a record on the serial team's stack */
             kmp_internal_control_t * control = (kmp_internal_control_t *) __kmp_allocate(sizeof(kmp_internal_control_t));
 
-#if OMP_30_ENABLED
             copy_icvs( control, & thread->th.th_current_task->td_icvs );
-#else
-            control->nproc        = thread->th.th_team->t.t_set_nproc[0];
-            control->dynamic      = thread->th.th_team->t.t_set_dynamic[0];
-            control->nested       = thread->th.th_team->t.t_set_nested[0];
-            control->blocktime    = thread->th.th_team->t.t_set_blocktime[0];
-            control->bt_intervals = thread->th.th_team->t.t_set_bt_intervals[0];
-            control->bt_set       = thread->th.th_team->t.t_set_bt_set[0];
-#endif // OMP_30_ENABLED
 
             control->serial_nesting_level = thread->th.th_team->t.t_serialized;
 
-            control->next = thread -> th.th_team -> t.t_control_stack_top;
-            thread -> th.th_team -> t.t_control_stack_top = control;
+            control->next = thread->th.th_team->t.t_control_stack_top;
+            thread->th.th_team->t.t_control_stack_top = control;
         }
     }
 }
@@ -3230,14 +2209,17 @@
     //
     root = thread->th.th_root;
     if ( __kmp_init_parallel && ( ! root->r.r_active )
-      && ( root->r.r_hot_team->t.t_nproc > new_nth ) ) {
+      && ( root->r.r_hot_team->t.t_nproc > new_nth )
+#if KMP_NESTED_HOT_TEAMS
+      && __kmp_hot_teams_max_level && !__kmp_hot_teams_mode
+#endif
+    ) {
         kmp_team_t *hot_team = root->r.r_hot_team;
         int f;
 
         __kmp_acquire_bootstrap_lock( &__kmp_forkjoin_lock );
 
 
-#if OMP_30_ENABLED
         if ( __kmp_tasking_mode != tskm_immediate_exec ) {
             kmp_task_team_t *task_team = hot_team->t.t_task_team;
             if ( ( task_team != NULL ) && TCR_SYNC_4(task_team->tt.tt_active) ) {
@@ -3259,7 +2241,6 @@
                 KMP_DEBUG_ASSERT( task_team == NULL );
             }
         }
-#endif // OMP_30_ENABLED
 
         //
         // Release the extra threads we don't need any more.
@@ -3270,6 +2251,12 @@
             hot_team->t.t_threads[f] =  NULL;
         }
         hot_team->t.t_nproc = new_nth;
+#if KMP_NESTED_HOT_TEAMS
+        if( thread->th.th_hot_teams ) {
+            KMP_DEBUG_ASSERT( hot_team == thread->th.th_hot_teams[0].hot_team );
+            thread->th.th_hot_teams[0].hot_team_nth = new_nth;
+        }
+#endif
 
 
         __kmp_release_bootstrap_lock( &__kmp_forkjoin_lock );
@@ -3283,13 +2270,12 @@
         }
 #if KMP_MIC
         // Special flag in case omp_set_num_threads() call
-        hot_team -> t.t_size_changed = -1;
+        hot_team->t.t_size_changed = -1;
 #endif
     }
 
 }
 
-#if OMP_30_ENABLED
 /* Changes max_active_levels */
 void
 __kmp_set_max_active_levels( int gtid, int max_active_levels )
@@ -3338,10 +2324,10 @@
     KMP_DEBUG_ASSERT( __kmp_init_serial );
 
     thread = __kmp_threads[ gtid ];
-    KMP_DEBUG_ASSERT( thread -> th.th_current_task );
+    KMP_DEBUG_ASSERT( thread->th.th_current_task );
     KF_TRACE( 10, ( "__kmp_get_max_active_levels: thread %d, curtask=%p, curtask_maxaclevel=%d\n",
-        gtid, thread -> th.th_current_task, thread -> th.th_current_task -> td_icvs.max_active_levels ) );
-    return thread -> th.th_current_task -> td_icvs.max_active_levels;
+        gtid, thread->th.th_current_task, thread->th.th_current_task->td_icvs.max_active_levels ) );
+    return thread->th.th_current_task->td_icvs.max_active_levels;
 }
 
 /* Changes def_sched_var ICV values (run-time schedule kind and chunk) */
